//+------------------------------------------------------------------+
//|                                                        Xmacd.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                          Xma.mq4 |
//|                 Copyright  2009, XrustSolution. Toys from Vinin.|
//|              http://www.xrust.ucoz.net  http://www.vinin.ucoz.ru |
//|                  xrust@land.ru  xrust@gmail.com  xrust@mksat.net |
//|            , |
//|                   |   
//-------------------------------------------------------------------+
#property copyright "#Copyright  2008, XrustSolution.#"
#property link      "#http://www.xrust.ucoz.net#"
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 PaleGreen
#property indicator_color2 Silver
#property indicator_color3 Goldenrod
#property indicator_color4 Orchid
#property indicator_color5 MediumBlue
#property indicator_color6 Maroon

extern int period=12;
extern int period1=26;
extern int filter=10;
extern double StDv = 2.0;
int metod =1;
int metod2=1;
int prise =0;
//---- buffers
int porog =3;
double Price[];
double MACD[];
double Signal[];
double Ichimoku[];
double BandUp[];
double BandDw[];
double avg, sDev;
//+------------------------------------------------------------------+
void init(){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,Price);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,0);
   SetIndexBuffer(1,MACD);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexDrawBegin(2,0);
   SetIndexBuffer(2,Signal);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexDrawBegin(3,0);
   SetIndexBuffer(3,Ichimoku);
   SetIndexStyle(4,DRAW_LINE,2);
   SetIndexDrawBegin(4,0);
   SetIndexBuffer(4,BandUp);
   SetIndexStyle(5,DRAW_LINE,2);
   SetIndexDrawBegin(5,0);
   SetIndexBuffer(5,BandDw);
   SetIndexLabel(0,"Price ;"+3+" ; "+period);
   SetIndexLabel(1,"MACD ;"+period+" ; "+period1);
   SetIndexLabel(2,"Signal ;"+period+" ; "+period1+" ; "+filter);
   SetIndexLabel(3,"Ichimoku ;"+9+" ; "+26+" ; "+52);
   IndicatorShortName("Xmacd ; "+period+" ; "+period1+" ; "+filter);
   switch(Period())
      {
      case     1: porog=0.5*filter;  break;
      case     5: porog=1*filter;    break;
      case    15: porog=2*filter;    break;
      case    30: porog=3*filter;    break;
      case    60: porog=3*filter;    break;
      case   240: porog=4*filter;    break;
      case  1440: porog=6*filter;    break;
      case 10080: porog=10*filter;   break;
      case 43200: porog=10*filter;   break;
      }
return;} 
//+------------------------------------------------------------------+
int start() {
   int limit;
   double tmp1,tmp2;
   int counted_bars=IndicatorCounted();
   int i;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for (i = limit;i>=0;i--){
     
     Price[i]=iMA(Symbol(),0,3,0,metod,prise,i)-iMA(Symbol(),0,period,0,metod,prise,i);
     MACD[i] =iMA(Symbol(),0,period,0,metod,prise,i)-iMA(Symbol(),0,period1,0,metod,prise,i);
     Ichimoku[i]=iIchimoku(NULL,0,9,26,52,MODE_TENKANSEN,i)-iIchimoku(NULL,0,9,26,52,MODE_KIJUNSEN,i);
     tmp1=iMA(Symbol(),0,period,0,metod,prise,i)-iMA(Symbol(),0,period1,0,metod,prise,i);
     tmp2=iMA(Symbol(),0,period,1,metod2,prise,i)-iMA(Symbol(),0,period1,1,metod2,prise,i); 
     if(MathAbs(tmp1-tmp2)>=porog*Point){
       Signal[i]=tmp2;
     }else{
       Signal[i]=Signal[i+1];
     }
   }
   for (i = limit;i>=0;i--)
     {
       avg = iMAOnArray(Price, 0, 20, 0, MODE_EMA, i);
       sDev = iStdDevOnArray(Price, 0, 20, 0, MODE_EMA, i);
       BandUp[i] = avg + (StDv * sDev);  // Upperband 
       BandDw[i] = avg - (StDv * sDev);  // Lowerband
     }
   return(0);}
//+------------------------------------------------------------------+   

